std::move_iterator::move_iterator(3)

NAME
std::move_iterator::move_iterator - std::move_iterator::move_iterator

Synopsis
   move_iterator(); (until C++17)
   constexpr move_iterator(); (since C++17)
   explicit move_iterator( (until C++17)
   iterator_type x );
   constexpr explicit move_iterator( (since C++17)
   iterator_type x ); (1)
   template< class U > (2)
   move_iterator( const (until C++17)
   move_iterator<U>& other ); (3)
   template< class U >
   constexpr move_iterator( const (since C++17)
   move_iterator<U>& other );
   Constructs a new iterator adaptor.
   1) Default constructor. The underlying iterator is value-initialized. Operations on
   the resulting iterator have defined behavior if and only if the corresponding
   operations on a value-initialized Iter also have defined behavior.
   2) The underlying iterator is initialized with
   x
   (until C++20)
   std::move(x)
   (since C++20).
   3) The underlying iterator is initialized with that of other.
   The behavior is undefined if U is not convertible to Iter
   (until C++20)
   This overload participates in overload resolution only if U is not the same type as
   Iter and std::convertible_to<const U&, Iter> is modeled
   (since C++20).

Parameters
   x - iterator to adapt
   other - iterator adaptor to copy

Example
    This section is incomplete
    Reason: no example
  Defect reports
   The following behavior-changing defect reports were applied retroactively to
   previously published C++ standards.
      DR Applied to Behavior as published Correct behavior
   LWG 3435 C++20 the converting constructor from another constrained
                       move_iterator was not constrained

See also
   operator= assigns another iterator adaptor
   (C++11) (public member function)
   make_move_iterator creates a std::move_iterator of type inferred from the argument
   (C++11) (function template)